<!doctype html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link rel="icon" type="image/svg+xml" href="./favicon.svg" />
    <link rel="stylesheet" href="./style.css" />
    <title>Qu.Id Registration</title>
  </head>
  <body>
    <header>
      <div class="left">
        <img src="./logo.svg" alt="Quadratic" />
      </div>
      <div class="right">
        <div class="wallet">
          <div id="quadBalanceDetails">
            <img src="./logo.svg" alt="" title="Your Qaudratic balance" />
            <span id="quadBalance"></span>
          </div>
          <w3m-button></w3m-button>
        </div>
      </div>
    </header>

    <main id="app">
      <div class="card">
        <h2>Register a Quadratic Identifier</h2>
        <form
          id="registerForm"
          name="registerForm"
          autocomplete="off"
          novalidate
        >
          <input
            type="url"
            id="uri"
            name="uri"
            placeholder="https://my.url/"
            required
          />

          <div id="registerError" class="error"></div>

          <div class="fees-grid">
            <div class="fees-row">
              <div>Minimum registration stake:</div>
              <div class="fees-end">
                <span id="minimumStakeAmount">0</span><span>&nbsp;QUAD</span>
              </div>
            </div>
            <div class="fees-row">
              <div>Registration fee:</div>
              <div class="fees-end">
                <span id="registrationFeeAmount">0</span><span>&nbsp;QUAD</span>
              </div>
            </div>
          </div>

          <div id="registerTxError"></div>

          <div class="button-group">
            <button
              id="approveRegister"
              name="approveRegister"
              type="submit"
              class="approve"
            >
              Approve<span id="approveRegisterInfo" class="popup-wrapper"
                ><svg
                  xmlns="http://www.w3.org/2000/svg"
                  width="1.5rem"
                  height="1.5rem"
                  viewBox="0 0 36 36"
                >
                  <circle
                    cx="17.93"
                    cy="11.9"
                    r="1.4"
                    fill="white"
                    class="clr-i-outline clr-i-outline-path-1"
                  />
                  <path
                    fill="white"
                    d="M21 23h-2v-8h-3a1 1 0 0 0 0 2h1v6h-2a1 1 0 1 0 0 2h6a1 1 0 0 0 0-2"
                    class="clr-i-outline clr-i-outline-path-2"
                  />
                  <path
                    fill="white"
                    d="M18 6a12 12 0 1 0 12 12A12 12 0 0 0 18 6m0 22a10 10 0 1 1 10-10a10 10 0 0 1-10 10"
                    class="clr-i-outline clr-i-outline-path-3"
                  />
                  <path fill="none" d="M0 0h36v36H0z" /></svg
                ><span class="popup" id="approveRegisterInfoPopup"
                  >By approving, you are permitting the Registrar to stake the
                  specified amount of Quadratic on your behalf.<br /><br />If no
                  amount is specified, you are approving the minimum stake
                  amount.</span
                ></span
              >
            </button>
            <button id="register" name="register" type="submit" disabled>
              Register
            </button>
            <button id="connectWallet" name="connectWallet" disabled>
              Connect Wallet
            </button>
            <button
              id="insufficientQuadBalance"
              name="insufficientQuadBalance"
              disabled
            >
              Insufficient Quadratic balance
            </button>
          </div>
        </form>
      </div>

      <aside id="registerInfoPanel">
        <article>
          <h4>What is a Quadratic Identifier</h4>
          <p>
            Quadratic Identifiers are identifiers for any kind of digital object
            describing scientific or academic information.
          </p>
          <p>
            A Quadratic Identifier is permanent and persistent. Even if the
            location of your information changes it can still be found because
            the Quadratic Identifier remains unchanged.
          </p>
          <p>
            <a
              href="https://docs.quadratic.systems/ecosystem/quid.html"
              target="_blank"
              >Learn more</a
            >
          </p>
        </article>
      </aside>

      <aside id="quids"></aside>
    </main>

    <footer>
      <div class="footer-left">&copy; Quadratic Systems</div>
      <div class="footer-right">version:&nbsp;<span id="version"></span></div>
    </footer>

    <dialog id="changeUriDialog" class="card">
      <button class="modal-close modal-x-close" data-parent="changeUriDialog">
        x
      </button>
      <div class="dialog-body">
        <h2>Change URI</h2>
        <h3 id="handle"></h3>
        <form
          method="dialog"
          id="changeUriForm"
          name="changeUriForm"
          autocomplete="off"
          novalidate
        >
          <input type="hidden" name="id" />
          <input
            type="url"
            id="uri"
            name="uri"
            placeholder="https://my.url/"
            required
            autofocus
          />

          <div id="changeUriError" class="error"></div>

          <div id="changeUriTxError"></div>

          <button type="submit" id="changeUri" name="changeUri">Save</button>
        </form>
        <button
          class="modal-close modal-cancel-close"
          data-parent="changeUriDialog"
        >
          cancel
        </button>
      </div>
    </dialog>

    <dialog id="deregisterDialog" class="card">
      <button class="modal-close modal-x-close" data-parent="deregisterDialog">
        x
      </button>
      <div class="dialog-body">
        <h2>Deregister</h2>
        <p>You are about to deregister the handle:</p>
        <h3 id="handle"></h3>
        <p>
          This will burn the associated token and will release the remaining
          Quadratic tokens into your wallet.
        </p>
        <form
          method="dialog"
          id="deregisterForm"
          name="deregisterForm"
          autocomplete="off"
        >
          <input type="hidden" name="id" />

          <div id="deregisterTxError"></div>

          <div class="button-group">
            <button
              type="submit"
              name="approveDeregister"
              id="approveDeregister"
              class="approve show"
            >
              Approve<span id="approveDeregisterInfo" class="popup-wrapper"
                ><svg
                  xmlns="http://www.w3.org/2000/svg"
                  width="1.5rem"
                  height="1.5rem"
                  viewBox="0 0 36 36"
                >
                  <circle
                    cx="17.93"
                    cy="11.9"
                    r="1.4"
                    fill="white"
                    class="clr-i-outline clr-i-outline-path-1"
                  />
                  <path
                    fill="white"
                    d="M21 23h-2v-8h-3a1 1 0 0 0 0 2h1v6h-2a1 1 0 1 0 0 2h6a1 1 0 0 0 0-2"
                    class="clr-i-outline clr-i-outline-path-2"
                  />
                  <path
                    fill="white"
                    d="M18 6a12 12 0 1 0 12 12A12 12 0 0 0 18 6m0 22a10 10 0 1 1 10-10a10 10 0 0 1-10 10"
                    class="clr-i-outline clr-i-outline-path-3"
                  />
                  <path fill="none" d="M0 0h36v36H0z" /></svg
                ><span class="popup" id="approveDeregisterInfoPopup"
                  >The registrar requires your explicit approval to deregister
                  this Quadratic Identifier.</span
                ></span
              >
            </button>
            <button type="submit" name="deregister" id="deregister" disabled>
              Deregister
            </button>
          </div>
        </form>
        <button
          class="modal-close modal-cancel-close"
          data-parent="deregisterDialog"
        >
          cancel
        </button>
      </div>
    </dialog>

    <dialog id="doneDialog" class="card">
      <button class="modal-close modal-x-close" data-parent="doneDialog">
        x
      </button>
      <div class="dialog-body">
        <h2>Transaction completed</h2>
        <button name="done" id="done">Done</button>
      </div>
    </dialog>

    <script type="module" src="./index.js"></script>
  </body>
</html>
